Subject: Re: linux-next: build warnings after merge of the final tree (tip treee related)

From: Stephen Rothwell <[email-masked]>
Date: Tue, 14 Sep 2010 14:50:25 +1000

Hi Yinghai,

On Mon, 13 Sep 2010 01:24:20 -0700 Yinghai Lu <[email-masked]> wrote:
>
> On 09/12/2010 09:39 PM, Stephen Rothwell wrote:
> > 
> > Your patch fixes some of the warnings, but still leaves these for a
> > powerpc allnoconfig build:
> > 
> > WARNING: mm/built-in.o(.text+0x25d80): Section mismatch in reference from the function memblock_double_array() to the function .init.text:memblock_free()
> > The function memblock_double_array() references
> > the function __init memblock_free().
> > This is often because memblock_double_array lacks a __init 
> > annotation or the annotation of memblock_free is wrong.
> > 
> > WARNING: mm/built-in.o(.text+0x26318): Section mismatch in reference from the function memblock_reserve_reserved_regions() to the function .init.text:memblock_reserve()
> > The function memblock_reserve_reserved_regions() references
> > the function __init memblock_reserve().
> > This is often because memblock_reserve_reserved_regions lacks a __init 
> > annotation or the annotation of memblock_reserve is wrong.
> > 
> > WARNING: mm/built-in.o(.text+0x26490): Section mismatch in reference from the function memblock_free_reserved_regions() to the function .init.text:memblock_free()
> > The function memblock_free_reserved_regions() references
> > the function __init memblock_free().
> > This is often because memblock_free_reserved_regions lacks a __init 
> > annotation or the annotation of memblock_free is wrong.
> 
> v1 already changed them all to __init_memblock, so we should not have those warnings.

They are still marked as __init in include/linux/memblock.h.  I don't
think that they need to be marked at all there.

> > And these for a i386 defconfig build:
> > 
> > WARNING: mm/built-in.o(.text+0x1e261): Section mismatch in reference from the function memblock_is_memory() to the variable .init.data:memblock
> > The function memblock_is_memory() references
> > the variable __initdata memblock.
> > This is often because memblock_is_memory lacks a __initdata 
> > annotation or the annotation of memblock is wrong.
> > 
> > WARNING: mm/built-in.o(.text+0x1e27f): Section mismatch in reference from the function memblock_is_region_memory() to the variable .init.data:memblock
> > The function memblock_is_region_memory() references
> > the variable __initdata memblock.
> > This is often because memblock_is_region_memory lacks a __initdata 
> > annotation or the annotation of memblock is wrong.
> 
> you must have old gcc, those functions are not used with i386.

I am not sure what the compiler version has to do with it, but I am using
gcc 4.4.4 which is fairly recent.  The X86 Kconfig selects HAVE_MEMBLOCK
unconditionally, so mm/memblock.c is built on i386.

-- 
Cheers,
Stephen Rothwell                    [email-masked]
http://www.canb.auug.org.au/~sfr/